using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DateTimePickerAdvBug
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			DummyClass dummy = new DummyClass();

			dateTimePickerAdv1.DataBindings.Add("Value", dummy, "Date1");
			dateTimePickerAdv2.DataBindings.Add("Value", dummy, "Date2");
		}

		private void dateTimePickerAdv1_ValueChanged(object sender, EventArgs e)
		{
			if (dateTimePickerAdv1.Value.Year == 1907)
			{
				MessageBox.Show("BUG! The 'dateTimePickerAdv1' year value is now 1907 but it should still be 2007!");
			}
		}

		private void dateTimePickerAdv2_ValueChanged(object sender, EventArgs e)
		{
			if (dateTimePickerAdv2.Value.Year == 1907)
			{
				MessageBox.Show("BUG! The 'dateTimePickerAdv2' year value is now 1907 but it should still be 2007!");
			}
		}
	}

	public class DummyClass
	{
		DateTime date1 = new DateTime(2007, 10, 20);
		DateTime date2 = new DateTime(2007, 12, 25);

		public DateTime Date1
		{
			get { return date1; }
			set { date1 = value; }
		}

		public DateTime Date2
		{
			get { return date2; }
			set { date2 = value; }
		}
	}
}